#!/usr/bin/env python3

import math

def get_snapshot(k):
    if m != n_proc and k > k_end - max_delta:
        print("---------------")
        print("receive", k)
    
def dispatch_snapshot(k):
    if m != 1 and k < k_begin + max_delta: print("send", k)
    
max_delta = 4
n_dates = 15
n_proc = 3
assert n_proc <= n_dates // (max_delta + 1)

for m in range(1, n_proc + 1):
    print("\nm = ", m)
    print("prolog")
    k_begin = 1 + math.floor((m - 1) * n_dates / n_proc)

    if m < n_proc:
        k_end = math.floor(m * n_dates / n_proc) + max_delta
        k_end_main_loop = k_end - max_delta + 1
    else:
        k_end = n_dates
        k_end_main_loop = k_end

    print("k_begin =", k_begin)
    print("k_end_main_loop =", k_end_main_loop)
    print("k_end =", k_end)

    for k in range(k_begin, k_begin + max_delta + 1):
        get_snapshot(k)

    for delta in range(1, max_delta + 1):
        for k in range(k_begin + delta, k_begin + max_delta + 1):
            print("overlap", k - delta, k)

    print("main loop")

    for k in range(k_begin + max_delta + 1, k_end_main_loop + 1):
        dispatch_snapshot(k - max_delta - 1)
        get_snapshot(k)

        for delta in range(1, max_delta + 1):
            print("overlap", k - delta, k)

    print("epilog")

    for k in range(k_end_main_loop + 1, k_end + 1):
         dispatch_snapshot(k - max_delta - 1)
         get_snapshot(k)

         for delta in range(k - k_end + max_delta, max_delta + 1):
              print("overlap", k - delta, k)

    for j in range(1, max_delta + 2):
        dispatch_snapshot(k_end - max_delta - 1 + j)
